package cz.cnb.anaws;

import java.io.*;
import java.util.zip.GZIPInputStream;
import java.util.ArrayList;
import java.util.List;

// This source file is generated by Oracle tools.
// Contents may be subject to change.
// For reporting problems, use the following:
// Generated by Oracle JDeveloper 12c 12.2.1.2.0.1224
public class AnaWSClient {
    public static void main(String[] args) throws Exception {
        String dir = "C:\\anacredit\\";
        
        AnaWS_Service anaWS_Service = new AnaWS_Service();
        AnaWS anaWS = anaWS_Service.getAnaWS();

        System.setProperty("javax.net.ssl.keyStore", dir+"anaws.pfx");
        System.setProperty("javax.net.ssl.keyStorePassword", "heslo");
        
        String subjekt = "9999";
        String datovy_soubor = "PANACR02";
        String obdobi = "30.04.2020";
        String obdobi_yyyymmdd = "20200430";

        // getInfo
        GenericRequestResponseHeader getInfoRequest = new GenericRequestResponseHeader();
        getInfoRequest.setSubjekt(subjekt);
        getInfoRequest.setDatovySoubor(datovy_soubor);
        getInfoRequest.setObdobi(obdobi);
        GetInfoResponse getInfoResponse = anaWS.getInfo(getInfoRequest);
        
        // getData
        GetDataRequest getDataRequest = new GetDataRequest();
        getDataRequest.setSubjekt(subjekt);
        getDataRequest.setDatovySoubor(datovy_soubor);
        getDataRequest.setObdobi(obdobi);
        getDataRequest.setStavKeDni(getInfoResponse.getDataStavKeDni());
        GetDataResponse getDataResponse = anaWS.getData(getDataRequest);
        saveFile(dir+subjekt+"_"+datovy_soubor+"_"+obdobi_yyyymmdd+".csv", getDataResponse.getGzipCsvData().getInputStream());

        // getProtokoly JVK
        GetProtokolyRequest getProtokolyRequest = new GetProtokolyRequest();
        getProtokolyRequest.setSubjekt(subjekt);
        getProtokolyRequest.setDatovySoubor(datovy_soubor);
        getProtokolyRequest.setObdobi(obdobi);
        GetInfoResponse.Jvk jvk = getInfoResponse.getJvk();
        getProtokolyRequest.setStavKeDni(jvk.getStavKeDni());
        List<JvkMvkChyba> jvk_chyby = jvk.getJvkKkId();
        for(int i=0;i<jvk_chyby.size();i++) {
            String jvk_kk_id = Integer.toString(jvk_chyby.get(i).getKkId());
            getProtokolyRequest.setJvkKkId(jvk_kk_id);
            GetProtokolyResponse getProtokolyResponse = anaWS.getProtokoly(getProtokolyRequest);
            String filename = subjekt+"_"+datovy_soubor+"_"+obdobi_yyyymmdd+"_JVK_"+jvk_kk_id+".csv";
            saveFile(dir+filename, getProtokolyResponse.getGzipCsvData().getInputStream());
        }
        
        // getProtokoly MVK
        getProtokolyRequest = new GetProtokolyRequest();
        getProtokolyRequest.setSubjekt(subjekt);
        getProtokolyRequest.setDatovySoubor(datovy_soubor);
        getProtokolyRequest.setObdobi(obdobi);
        GetInfoResponse.Mvk mvk = getInfoResponse.getMvk();
        List<GetInfoResponse.Mvk.MvkMkId> mvk_list = mvk.getMvkMkId();
        for(int i=0;i<mvk_list.size();i++) {
            String mk_id = mvk_list.get(i).getMkId();
            String stav_ke_dni = mvk_list.get(i).getStavKeDni();
            List<JvkMvkChyba> mvk_chyby = mvk_list.get(i).getMvkKkId();
            for(int j=0;j<mvk_chyby.size();j++) {
                String mk_id_kk_id = Integer.toString(mvk_chyby.get(i).getKkId());
                getProtokolyRequest.setStavKeDni(stav_ke_dni);
                getProtokolyRequest.setMvkMkId(mk_id);
                getProtokolyRequest.setMvkMkIdKkId(mk_id_kk_id);
                GetProtokolyResponse getProtokolyResponse = anaWS.getProtokoly(getProtokolyRequest);
                String filename = subjekt+"_"+datovy_soubor+"_"+obdobi_yyyymmdd+"_MVK_"+mk_id+"_"+mk_id_kk_id+".csv";
                saveFile(dir+filename, getProtokolyResponse.getGzipCsvData().getInputStream());
            }
        }

        // getStavy
        GetDataRequest getStavyRequest = new GetDataRequest();
        getStavyRequest.setSubjekt(subjekt);
        getStavyRequest.setDatovySoubor(datovy_soubor);
        getStavyRequest.setObdobi(obdobi);
        getStavyRequest.setStavKeDni(getInfoResponse.getStavyStavKeDni());
        GetDataResponse getStavyResponse = anaWS.getStavy(getStavyRequest);
        saveFile(dir+subjekt+"_"+datovy_soubor+"_"+obdobi_yyyymmdd+"_STAVY.csv", getStavyResponse.getGzipCsvData().getInputStream());
    }

    private static void saveFile(String path, InputStream is) throws IOException {
        GZIPInputStream z = new GZIPInputStream(is);
        File f = new File(path);
        byte[] buffer = new byte[1000 * 1024];
        int bytesRead;
        try (OutputStream os = new FileOutputStream(f)) {
            while ((bytesRead = z.read(buffer)) != -1) {
                os.write(buffer, 0, bytesRead);
            }
            z.close();
        }
    }

}
